// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Gdipfill.pas' rev: 10.00

#ifndef GdipfillHPP
#define GdipfillHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Advsmoothgdip.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Clipbrd.hpp>	// Pascal unit
#include <Inifiles.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Gdipfill
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TFillPicturePosition { ppTopLeft, ppTopCenter, ppTopRight, ppBottomLeft, ppBottomCenter, ppBottomRight, ppTiled, ppStretched, ppCenterLeft, ppCenterCenter, ppCenterRight, ppCustom };
#pragma option pop

#pragma option push -b-
enum TFillRoundingType { rtNone, rtTop, rtBottom, rtBoth, rtLeft, rtRight };
#pragma option pop

#pragma option push -b-
enum TFillPictureSize { psOriginal, psCustom };
#pragma option pop

#pragma option push -b-
enum TFillPictureMode { pmInsideFill, pmOutsideFill };
#pragma option pop

class DELPHICLASS TGDIPFill;
class PASCALIMPLEMENTATION TGDIPFill : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TColor FBorderColor;
	Byte FOpacity;
	TFillPicturePosition FPicturePosition;
	Advsmoothgdip::TAdvGradientType FGradientType;
	Byte FOpacityTo;
	Advsmoothgdip::TAdvGDIPPicture* FPicture;
	Advsmoothgdip::HatchStyle FHatchStyle;
	Graphics::TColor FColor;
	int FShadowOffset;
	Byte FOpacityMirror;
	Advsmoothgdip::TAdvGradientType FGradientMirrorType;
	Byte FOpacityMirrorTo;
	int FRounding;
	Graphics::TColor FShadowColor;
	int FBorderWidth;
	Graphics::TColor FColorMirror;
	Graphics::TColor FColorMirrorTo;
	Graphics::TColor FColorTo;
	Classes::TNotifyEvent FOnChange;
	Advsmoothgdip::HatchStyle FHatchStyleMirror;
	int FPictureTop;
	int FPictureLeft;
	int FBackGroundPictureTop;
	int FBackGroundPictureLeft;
	TFillPicturePosition FBackGroundPicturePosition;
	Advsmoothgdip::TAdvGDIPPicture* FBackGroundPicture;
	int FpictureWidth;
	TFillPictureSize FpictureSize;
	int FpictureHeight;
	TFillRoundingType FRoundingType;
	int FUpdateCount;
	bool FFocus;
	Graphics::TColor FFocusColor;
	int FAngle;
	Byte FBorderOpacity;
	#pragma pack(push,1)
	Advsmoothgdip::TGPRectF FFocusRect;
	#pragma pack(pop)
	TFillPictureMode FBackGroundPictureMode;
	void __fastcall SetBorderColor(const Graphics::TColor Value);
	void __fastcall SetBorderWidth(const int Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorMirror(const Graphics::TColor Value);
	void __fastcall SetColorMirrorTo(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetGradientMirrorType(const Advsmoothgdip::TAdvGradientType Value);
	void __fastcall SetGradientType(const Advsmoothgdip::TAdvGradientType Value);
	void __fastcall SetHatchStyle(const Advsmoothgdip::HatchStyle Value);
	void __fastcall SetOpacity(const Byte Value);
	void __fastcall SetOpacityMirror(const Byte Value);
	void __fastcall SetOpacityMirrorTo(const Byte Value);
	void __fastcall SetOpacityTo(const Byte Value);
	void __fastcall SetPicture(const Advsmoothgdip::TAdvGDIPPicture* Value);
	void __fastcall SetPicturePosition(const TFillPicturePosition Value);
	void __fastcall SetRounding(const int Value);
	void __fastcall SetShadowColor(const Graphics::TColor Value);
	void __fastcall SetShadowOffset(const int Value);
	void __fastcall SetHatchStyleMirror(const Advsmoothgdip::HatchStyle Value);
	void __fastcall SetPictureLeft(const int Value);
	void __fastcall SetPictureTop(const int Value);
	void __fastcall SetBackGroundPicture(const Advsmoothgdip::TAdvGDIPPicture* Value);
	void __fastcall SetBackGroundPictureLeft(const int Value);
	void __fastcall SetBackGroundPicturePosition(const TFillPicturePosition Value);
	void __fastcall SetBackGroundPictureTop(const int Value);
	void __fastcall SetPictureHeight(const int Value);
	void __fastcall SetPictureSize(const TFillPictureSize Value);
	void __fastcall SetPictureWidth(const int Value);
	void __fastcall SetRoundingType(const TFillRoundingType Value);
	void __fastcall SetFocus(const bool Value);
	void __fastcall SetFocusColor(const Graphics::TColor Value);
	void __fastcall SetAngle(const int Value);
	void __fastcall SetBorderOpacity(const Byte Value);
	void __fastcall SetBackGroundPictureMode(const TFillPictureMode Value);
	
protected:
	void __fastcall Changed(void);
	void __fastcall PictureChanged(System::TObject* Sender);
	void __fastcall DrawGradientBackGround(Advsmoothgdip::TGPGraphics* Graphics, const Advsmoothgdip::TGPRectF &R, bool Mirror, Byte oc, Byte octo, Byte ocmr, Byte ocmrto);
	
public:
	__fastcall TGDIPFill(void);
	__fastcall virtual ~TGDIPFill(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	Advsmoothgdip::TGPRectF __fastcall Fill(Advsmoothgdip::TGPGraphics* Graphics, const Advsmoothgdip::TGPRectF &R, Byte ABorderOpacity = (Byte)(0xff), Byte AOpacity = (Byte)(0xff), Byte AOpacityTo = (Byte)(0xff), Byte AOpacityMirror = (Byte)(0xff), Byte AOpacityMirrorTo = (Byte)(0xff));
	void __fastcall BeginUpdate(void);
	void __fastcall EndUpdate(void);
	void __fastcall SaveToClipBoard(void);
	void __fastcall LoadFromClipBoard(void);
	__property bool Focus = {read=FFocus, write=SetFocus, default=0};
	__property Graphics::TColor FocusColor = {read=FFocusColor, write=SetFocusColor, default=0};
	__property Advsmoothgdip::TGPRectF FocusRect = {read=FFocusRect, write=FFocusRect};
	void __fastcall SaveToFile(AnsiString FileName, AnsiString Section)/* overload */;
	void __fastcall SaveToFile(Inifiles::TIniFile* ini, AnsiString Section)/* overload */;
	void __fastcall LoadFromFile(AnsiString FileName, AnsiString Section)/* overload */;
	void __fastcall LoadFromFile(Inifiles::TIniFile* ini, AnsiString Section)/* overload */;
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=12632256};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=8421504};
	__property Graphics::TColor ColorMirror = {read=FColorMirror, write=SetColorMirror, nodefault};
	__property Graphics::TColor ColorMirrorTo = {read=FColorMirrorTo, write=SetColorMirrorTo, nodefault};
	__property Advsmoothgdip::TAdvGradientType GradientType = {read=FGradientType, write=SetGradientType, default=2};
	__property Advsmoothgdip::TAdvGradientType GradientMirrorType = {read=FGradientMirrorType, write=SetGradientMirrorType, default=0};
	__property Advsmoothgdip::HatchStyle HatchStyle = {read=FHatchStyle, write=SetHatchStyle, default=0};
	__property Advsmoothgdip::HatchStyle HatchStyleMirror = {read=FHatchStyleMirror, write=SetHatchStyleMirror, default=0};
	__property TFillPictureMode BackGroundPictureMode = {read=FBackGroundPictureMode, write=SetBackGroundPictureMode, default=1};
	__property Advsmoothgdip::TAdvGDIPPicture* BackGroundPicture = {read=FBackGroundPicture, write=SetBackGroundPicture};
	__property TFillPicturePosition BackGroundPicturePosition = {read=FBackGroundPicturePosition, write=SetBackGroundPicturePosition, default=0};
	__property int BackGroundPictureLeft = {read=FBackGroundPictureLeft, write=SetBackGroundPictureLeft, default=0};
	__property int BackGroundPictureTop = {read=FBackGroundPictureTop, write=SetBackGroundPictureTop, default=0};
	__property Advsmoothgdip::TAdvGDIPPicture* Picture = {read=FPicture, write=SetPicture};
	__property TFillPicturePosition PicturePosition = {read=FPicturePosition, write=SetPicturePosition, default=0};
	__property int PictureLeft = {read=FPictureLeft, write=SetPictureLeft, default=0};
	__property int PictureTop = {read=FPictureTop, write=SetPictureTop, default=0};
	__property TFillPictureSize PictureSize = {read=FpictureSize, write=SetPictureSize, default=0};
	__property int PictureWidth = {read=FpictureWidth, write=SetPictureWidth, default=50};
	__property int PictureHeight = {read=FpictureHeight, write=SetPictureHeight, default=50};
	__property Byte Opacity = {read=FOpacity, write=SetOpacity, default=255};
	__property Byte OpacityTo = {read=FOpacityTo, write=SetOpacityTo, default=255};
	__property Byte OpacityMirror = {read=FOpacityMirror, write=SetOpacityMirror, default=255};
	__property Byte OpacityMirrorTo = {read=FOpacityMirrorTo, write=SetOpacityMirrorTo, default=255};
	__property Graphics::TColor BorderColor = {read=FBorderColor, write=SetBorderColor, default=536870911};
	__property Byte BorderOpacity = {read=FBorderOpacity, write=SetBorderOpacity, default=255};
	__property int BorderWidth = {read=FBorderWidth, write=SetBorderWidth, default=1};
	__property int Rounding = {read=FRounding, write=SetRounding, nodefault};
	__property TFillRoundingType RoundingType = {read=FRoundingType, write=SetRoundingType, default=3};
	__property Graphics::TColor ShadowColor = {read=FShadowColor, write=SetShadowColor, default=8421504};
	__property int ShadowOffset = {read=FShadowOffset, write=SetShadowOffset, nodefault};
	__property int Angle = {read=FAngle, write=SetAngle, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


#pragma option push -b-
enum TGDIPButtonLayout { blPictureLeft, blPictureRight, blPictureBottom, blPictureTop };
#pragma option pop

typedef void __fastcall (__closure *TFontStoredEvent)(System::TObject* Sender, bool &IsStored);

class DELPHICLASS TGDIPButton;
class PASCALIMPLEMENTATION TGDIPButton : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FUpdateCount;
	Graphics::TFont* FFont;
	Classes::TNotifyEvent FOnChange;
	Classes::TNotifyEvent FOnFontChange;
	TFontStoredEvent FOnIsFontStored;
	TGDIPButtonLayout FLayout;
	int FSpacing;
	int FShiftDown;
	Classes::TAlignment FAlignment;
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetLayout(const TGDIPButtonLayout Value);
	void __fastcall SetSpacing(const int Value);
	void __fastcall SetShiftDown(const int Value);
	bool __fastcall IsFontStored(void);
	void __fastcall SetAlignment(const Classes::TAlignment Value);
	
protected:
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall Changed(void);
	
public:
	void __fastcall BeginUpdate(void);
	void __fastcall EndUpdate(void);
	__fastcall TGDIPButton(void);
	__fastcall virtual ~TGDIPButton(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Advsmoothgdip::TGPGraphics* g, AnsiString Caption, int x, int y, int Width, int Height, int VerticalSpacing, int HorizontalSpacing, Graphics::TColor Color, Graphics::TColor ColorDown, Graphics::TColor BevelColor, bool Shadow, bool Down, bool Bevel, bool VerticalText, bool RightToLeft, TFillRoundingType RoundingType, Advsmoothgdip::TAdvGDIPPicture* Picture, int TextW, int TextH, bool WW);
	
__published:
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, default=0};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont, stored=IsFontStored};
	__property TGDIPButtonLayout Layout = {read=FLayout, write=SetLayout, default=0};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=3};
	__property int ShiftDown = {read=FShiftDown, write=SetShiftDown, default=1};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Classes::TNotifyEvent OnFontChange = {read=FOnFontChange, write=FOnFontChange};
	__property TFontStoredEvent OnIsFontStored = {read=FOnIsFontStored, write=FOnIsFontStored};
};


class DELPHICLASS TGDIPDialogButton;
class PASCALIMPLEMENTATION TGDIPDialogButton : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TFont* FFont;
	Classes::TNotifyEvent FOnChange;
	TGDIPButtonLayout FLayout;
	int FSpacing;
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetLayout(const TGDIPButtonLayout Value);
	void __fastcall SetSpacing(const int Value);
	
protected:
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall Changed(void);
	
public:
	__fastcall TGDIPDialogButton(void);
	__fastcall virtual ~TGDIPDialogButton(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Advsmoothgdip::TGPGraphics* g, AnsiString Caption, int x, int y, int Width, int Height, Graphics::TColor Color, Graphics::TColor BorderColor, int BorderWidth, Byte BorderOpacity, Byte Opacity, bool Border, bool Down, Advsmoothgdip::TAdvGDIPPicture* Picture, bool WW);
	
__published:
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property TGDIPButtonLayout Layout = {read=FLayout, write=SetLayout, default=0};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=3};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


class DELPHICLASS TGDIPStatus;
class PASCALIMPLEMENTATION TGDIPStatus : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FWidth;
	int FHeight;
	TGDIPFill* FFill;
	Graphics::TFont* FFont;
	Classes::TNotifyEvent FOnChange;
	bool FAutoSize;
	int FSpacing;
	bool FGlow;
	void __fastcall SetFill(const TGDIPFill* Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetSpacing(const int Value);
	void __fastcall SetGlow(const bool Value);
	
protected:
	void __fastcall FillChanged(System::TObject* Sender);
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall Changed(void);
	
public:
	__fastcall TGDIPStatus(void);
	__fastcall virtual ~TGDIPStatus(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Advsmoothgdip::TGPGraphics* g, int x, int y, int Width, int Height, bool AutoSize, AnsiString Caption);
	int __fastcall GetWidth(void);
	int __fastcall GetHeight(void);
	void __fastcall CalculateSize(Advsmoothgdip::TGPGraphics* g, AnsiString Caption);
	
__published:
	__property TGDIPFill* Fill = {read=FFill, write=SetFill};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=0};
	__property bool Glow = {read=FGlow, write=SetGlow, default=1};
};


#pragma option push -b-
enum TGDIPProgressValueType { vtPercentage, vtAbsolute };
#pragma option pop

#pragma option push -b-
enum TGDIPProgressValuePosition { vpProgressCenter, vpProgressRight, vpCenter, vpLeft, vpRight, vpCustom };
#pragma option pop

class DELPHICLASS TGDIPProgress;
class PASCALIMPLEMENTATION TGDIPProgress : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TGDIPFill* FBackGroundFill;
	AnsiString FValueFormat;
	TGDIPProgressValueType FValueType;
	TGDIPFill* FProgressFill;
	int FValuePositionTop;
	int FValuePositionLeft;
	Graphics::TFont* FFont;
	TGDIPProgressValuePosition FValuePosition;
	Classes::TNotifyEvent FOnChange;
	bool FValueVisible;
	Graphics::TFont* FProgressFont;
	bool FTransparent;
	void __fastcall SetBackGroundFill(const TGDIPFill* Value);
	void __fastcall SetFont(const Graphics::TFont* Value);
	void __fastcall SetProgressFill(const TGDIPFill* Value);
	void __fastcall SetValueFormat(const AnsiString Value);
	void __fastcall SetValuePosition(const TGDIPProgressValuePosition Value);
	void __fastcall SetValuePositionLeft(const int Value);
	void __fastcall SetValuePositionTop(const int Value);
	void __fastcall SetValueType(const TGDIPProgressValueType Value);
	void __fastcall SetValueVisible(const bool Value);
	void __fastcall SetProgressFont(const Graphics::TFont* Value);
	void __fastcall SetTransparent(const bool Value);
	
protected:
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall FillChanged(System::TObject* Sender);
	void __fastcall Changed(void);
	void __fastcall DrawBackGround(Advsmoothgdip::TGPGraphics* g, const Advsmoothgdip::TGPRectF &r);
	void __fastcall DrawShadows(Advsmoothgdip::TGPGraphics* g, const Advsmoothgdip::TGPRectF &r);
	void __fastcall DrawValue(Advsmoothgdip::TGPGraphics* g, const Types::TRect &r, double min, double max, double position);
	void __fastcall DrawProgress(Advsmoothgdip::TGPGraphics* g, const Types::TRect &r, double min, double max, double position);
	void __fastcall DrawOverLay(Advsmoothgdip::TGPGraphics* g, const Types::TRect &r);
	void __fastcall DrawGlow(Advsmoothgdip::TGPGraphics* g, const Types::TRect &r, double glowposition, double min, double max, double position);
	Types::TRect __fastcall InsideRect(const Types::TRect &r);
	void __fastcall GetTextSize(Advsmoothgdip::TGPGraphics* g, const Types::TRect &r, AnsiString s, Graphics::TFont* ft, Advsmoothgdip::TGPRectF &sizer);
	
public:
	__fastcall TGDIPProgress(void);
	__fastcall virtual ~TGDIPProgress(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Advsmoothgdip::TGPGraphics* g, const Types::TRect &r, double min, double max, double position);
	Advsmoothgdip::TGPRectF __fastcall GetInsideRectF(const Types::TRect &r);
	Advsmoothgdip::TGPRectF __fastcall CalculateProgressRectangle(const Types::TRect &r, double min, double max, double pos);
	
__published:
	__property bool Transparent = {read=FTransparent, write=SetTransparent, default=0};
	__property TGDIPFill* BackGroundFill = {read=FBackGroundFill, write=SetBackGroundFill};
	__property TGDIPFill* ProgressFill = {read=FProgressFill, write=SetProgressFill};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property Graphics::TFont* ProgressFont = {read=FProgressFont, write=SetProgressFont};
	__property AnsiString ValueFormat = {read=FValueFormat, write=SetValueFormat};
	__property TGDIPProgressValueType ValueType = {read=FValueType, write=SetValueType, default=1};
	__property TGDIPProgressValuePosition ValuePosition = {read=FValuePosition, write=SetValuePosition, default=2};
	__property int ValuePositionLeft = {read=FValuePositionLeft, write=SetValuePositionLeft, default=0};
	__property int ValuePositionTop = {read=FValuePositionTop, write=SetValuePositionTop, default=0};
	__property bool ValueVisible = {read=FValueVisible, write=SetValueVisible, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE Word CF_GDIPFILL;
extern PACKAGE Advsmoothgdip::TGPGraphicsPath* __fastcall CreateRoundRectangle(const Advsmoothgdip::TGPRectF &R, int Radius, TFillRoundingType RoundingType, bool Mirror)/* overload */;

}	/* namespace Gdipfill */
using namespace Gdipfill;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Gdipfill
